Crypto++ 8.0 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
InvertibleRWFunction Class Reference

Rabin-Williams trapdoor function using the private key. More...

Inheritance diagram for InvertibleRWFunction:

## Public Member Functions
| InvertibleRWFunction ()
| Construct an InvertibleRWFunction.
void | Initialize (const Integer &n, const Integer &p, const Integer &q, const Integer &u)
| Initialize a Rabin-Williams private key. More...
void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits)
| Create a Rabin-Williams private key. More...
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation. More...
void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation. More...
Integer | CalculateInverse (RandomNumberGenerator &rng, const Integer &x) const
| Calculates the inverse of an element. More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
const Integer & | GetMultiplicativeInverseOfPrime2ModPrime1 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
void | SetMultiplicativeInverseOfPrime2ModPrime1 (const Integer &u)
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int unused=0)
| Perform precomputation. More...
virtual void | Precompute (unsigned int unused=0) const
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
Public Member Functions inherited from RWFunction
void | Initialize (const Integer &n)
| Initialize a Rabin-Williams public key. More...
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor. More...
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied. More...
Integer | ImageBound () const
| Returns the maximum size of a message after the trapdoor function is applied. More...
const Integer & | GetModulus () const
void | SetModulus (const Integer &n)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function. More...
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized. More...
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key. More...
virtual Integer | MaxImage () const
| Returns the maximum size of a message after the trapdoor function is applied bound to a public key. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...
Public Member Functions inherited from TrapdoorFunctionInverse
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
| Applies the inverse of the trapdoor function. More...
bool | IsRandomized () const
| Determines if the decryption algorithm is randomized. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

Rabin-Williams trapdoor function using the private key.

Since
  Crypto++ 3.0, Tweaked roots using e and f since Crypto++ 5.6.4

Definition at line 59 of file rw.h.

## Member Function Documentation

## ◆ Initialize() [1/2]

void InvertibleRWFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | u
| ) |  |

Initialize a Rabin-Williams private key.

Parameters

  n | modulus
  p | first prime factor
  q | second prime factor
  u | q-1 mod p

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 118 of file rw.cpp.

## ◆ Initialize() [2/2]

void InvertibleRWFunction::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | modulusBits
| ) |  |
| inline

Create a Rabin-Williams private key.

Parameters

  rng | a RandomNumberGenerator derived class
  modulusBits | the size of the modulus, in bits

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 81 of file rw.h.

## ◆ Save()

void InvertibleRWFunction::Save | ( | BufferedTransformation & | bt | ) | const
| inline virtual

Saves a key to a BufferedTransformation.

Parameters

  bt | the destination BufferedTransformation

Exceptions

  NotImplemented |

Save() writes the material to a BufferedTransformation.

If the material is a key, then the key is written with ASN.1 DER encoding. The key includes an object identifier with an algorthm id, like a subjectPublicKeyInfo.

A "raw" key without the "key info" can be saved using a key's DEREncode() method.

If a derived class does not override Save(), then the base class throws NotImplemented().

Reimplemented from RWFunction.

Definition at line 87 of file rw.h.

## ◆ Load()

void InvertibleRWFunction::Load | ( | BufferedTransformation & | bt | ) |
| inline virtual

Loads a key from a BufferedTransformation.

Parameters

  bt | the source BufferedTransformation

Exceptions

  KeyingErr |

Load() attempts to read material from a BufferedTransformation. If the material is a key that was generated outside the library, then the following usually applies:

- the key should be ASN.1 BER encoded
- the key should be a "key info"

"key info" means the key should have an object identifier with an algorthm id, like a subjectPublicKeyInfo.

To read a "raw" key without the "key info", then call the key's BERDecode() method.

Note
  Load() generally does not check that the key is valid. Call Validate(), if needed.

Reimplemented from RWFunction.

Definition at line 89 of file rw.h.

## ◆ CalculateInverse()

Integer InvertibleRWFunction::CalculateInverse | ( | RandomNumberGenerator & | rng,
|  | const Integer & | x
| ) |  | const
| virtual

Calculates the inverse of an element.

Parameters

  rng | a RandomNumberGenerator derived class
  x | the element

Returns
  the inverse of the element in the group

Implements TrapdoorFunctionInverse.

Definition at line 188 of file rw.cpp.

## ◆ Validate()

bool InvertibleRWFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Reimplemented from RWFunction.

Definition at line 253 of file rw.cpp.

## ◆ GetVoidValue()

bool InvertibleRWFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Reimplemented from RWFunction.

Definition at line 278 of file rw.cpp.

## ◆ AssignFrom()

void InvertibleRWFunction::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Reimplemented from RWFunction.

Definition at line 287 of file rw.cpp.

## ◆ GenerateRandom()

void InvertibleRWFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) |  |
| virtual

parameters: (ModulusSize)

Reimplemented from GeneratableCryptoMaterial.

Definition at line 100 of file rw.cpp.

## ◆ SupportsPrecomputation()

virtual bool InvertibleRWFunction::SupportsPrecomputation | ( |  | ) | const
| inline virtual

Determines whether the object supports precomputation.

Returns
  true if the object supports precomputation, false otherwise

See also
  Precompute()

Reimplemented from CryptoMaterial.

Definition at line 109 of file rw.h.

## ◆ Precompute()

virtual void InvertibleRWFunction::Precompute | ( | unsigned int | precomputationStorage = `0` | ) |
| inline virtual

Perform precomputation.

Parameters

  precomputationStorage | the suggested number of objects for the precompute table

Exceptions

  NotImplemented |

The exact semantics of Precompute() varies, but it typically means calculate a table of n objects that can be used later to speed up computation.

If a derived class does not override Precompute(), then the base class throws NotImplemented.

See also
  SupportsPrecomputation(), LoadPrecomputation(), SavePrecomputation()

Reimplemented from CryptoMaterial.

Definition at line 110 of file rw.h.

## ◆ LoadPrecomputation()

void InvertibleRWFunction::LoadPrecomputation | ( | BufferedTransformation & | storedPrecomputation | ) |
| virtual

Retrieve previously saved precomputation.

Parameters

  storedPrecomputation | BufferedTransformation with the saved precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Reimplemented from CryptoMaterial.

Definition at line 142 of file rw.cpp.

## ◆ SavePrecomputation()

void InvertibleRWFunction::SavePrecomputation | ( | BufferedTransformation & | storedPrecomputation | ) | const
| virtual

Save precomputation for later use.

Parameters

  storedPrecomputation | BufferedTransformation to write the precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Reimplemented from CryptoMaterial.

Definition at line 153 of file rw.cpp.

The documentation for this class was generated from the following files:

- rw.h
- rw.cpp